<?xml version="1.0" encoding="ISO-8859-1"?><xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:SMLNL="http://www.shef.ac.uk/SpineMLNetworkLayer" xmlns:SMLLOWNL="http://www.shef.ac.uk/SpineMLLowLevelNetworkLayer" xmlns:SMLCL="http://www.shef.ac.uk/SpineMLComponentLayer"xmlns:fn="http://www.w3.org/2005/xpath-functions">
<xsl:output method="text" version="1.0" encoding="UTF-8" indent="yes"/>

<xsl:template match="SMLCL:Alias" mode="defineAlias">
<xsl:param name="suffix"/>
<xsl:variable name="this_name" select="@name"/>
<!-- all, unless they are also AnalogPorts -->
 <xsl:if test="count(//SMLCL:AnalogSendPort[@name=$this_name]) = 0">

	float <xsl:value-of select="@name"/>;
	
 </xsl:if>
</xsl:template>

<xsl:template match="SMLCL:Alias" mode="defineAliasSYN">
<xsl:param name="suffix"/>
float <xsl:value-of select="@name"/>;
</xsl:template>

<xsl:template match="SMLCL:Alias" mode="doAll">
<xsl:param name="suffix"/>
<xsl:variable name="this_name" select="@name"/>
<!-- all, unless they are also AnalogPorts -->
 <xsl:if test="count(//SMLCL:AnalogSendPort[@name=$this_name]) = 0">

 <xsl:value-of select="@name"/> = <!---->
 	<xsl:call-template name="add_suffix">
		<xsl:with-param name="params" select="//SMLCL:StateVariable | //SMLCL:AnalogReducePort | //SMLCL:AnalogReceivePort | //SMLCL:Alias"/>
		<xsl:with-param name="string" select="SMLCL:MathInline"/>
		<xsl:with-param name="suffix" select="concat($suffix, '[i]')"/>
	</xsl:call-template>;
</xsl:if>
</xsl:template>

<xsl:template match="SMLCL:Alias" mode="doPorts">
<xsl:param name="suffix"/>
<xsl:variable name="this_name" select="@name"/>
<!-- Analog*Ports -->
 	// aliases for output ports
 	<xsl:if test="count(//SMLCL:AnalogSendPort[@name=$this_name])=1">

 	<xsl:value-of select="@name"/><xsl:value-of select="concat($suffix, '[i]')"/> = <!---->
 	
 	<xsl:call-template name="add_suffix">
		<xsl:with-param name="params" select="//SMLCL:StateVariable | //SMLCL:AnalogReducePort | //SMLCL:AnalogReceivePort | //SMLCL:Alias"/>
		<xsl:with-param name="string" select="SMLCL:MathInline"/>
		<xsl:with-param name="suffix" select="concat($suffix, '[i]')"/>
	</xsl:call-template>;
</xsl:if>
</xsl:template>

<xsl:template match="SMLCL:Alias" mode="passPortAliases">
<xsl:param name="suffix"/>
<xsl:variable name="this_name" select="@name"/>
<!-- Analog*Ports -->
<xsl:if test="count(//SMLCL:AnalogSendPort[@name=$this_name])=1">
	<xsl:if test="contains($suffix,'INST')">float </xsl:if><xsl:value-of select="@name"/><xsl:value-of select="concat($suffix, '')"/>
 <!---->, <!---->
</xsl:if>
</xsl:template>

<xsl:template match="SMLCL:Alias" mode="doAliasSYN">
<xsl:param name="suffix"/>
<xsl:param name="props" select="//SMLCL:Parameter"/>
<xsl:variable name="this_name" select="@name"/>
<!-- all, unless they are also Analog*Ports -->
 <xsl:value-of select="@name"/> = <xsl:call-template name="add_suffix">
							<xsl:with-param name="params" select="$props[count(SMLNL:FixedValue)=0] | //SMLCL:StateVariable | //SMLCL:AnalogReducePort | //SMLCL:AnalogReceivePort | //SMLCL:Alias"/>
							<xsl:with-param name="string" select="SMLCL:MathInline"/>
							<xsl:with-param name="suffix" select="concat($suffix, '')"/>
							</xsl:call-template>;
</xsl:template>

<xsl:template match="SMLCL:Alias" mode="declareAliasSYN">
<xsl:param name="suffix"/>
<xsl:variable name="this_name" select="@name"/>
<!-- all, unless they are also Analog*Ports -->
	float <xsl:value-of select="@name"/>;
</xsl:template>

<xsl:template match="SMLCL:Alias" mode="initUpdates">
<xsl:param name="suffix"/>
	<xsl:variable name="aliasType"><xsl:call-template name="alias_type">
							<xsl:with-param name="stateVars" select="/SMLCL:SpineML/SMLCL:ComponentClass/SMLCL:Dynamics/SMLCL:StateVariable | /SMLCL:SpineML/SMLCL:ComponentClass/SMLCL:AnalogReducePort | /SMLCL:SpineML/SMLCL:ComponentClass/SMLCL:AnalogReceivePort"/>
							<xsl:with-param name="maths" select="SMLCL:MathInline"/>
							</xsl:call-template></xsl:variable>

<xsl:if test="normalize-space($aliasType) != 'true'">
 <xsl:value-of select="@name"/><xsl:value-of select="concat($suffix, '[i]')"/> = <xsl:call-template name="add_suffix">
							<xsl:with-param name="params" select="//SMLCL:Parameter | //SMLCL:StateVariable | //SMLCLAnalogReducePort | //SMLCLAnalogReceivePort | //SMLCL:Alias"/>
							<xsl:with-param name="string" select="SMLCL:MathInline"/>
							<xsl:with-param name="suffix" select="concat($suffix, '[i]')"/>
							</xsl:call-template>;
</xsl:if>
</xsl:template>


<xsl:template match="SMLCL:Alias" mode="doPortAssignments">
					//Alias assignment for ports
					<xsl:value-of select="@name"/>[num]=<xsl:call-template name="alias_replace">
							<xsl:with-param name="params" select="/SMLCL:SpineML/SMLCL:ComponentClass/SMLCL:Parameter | /SMLCL:SpineML/SMLCL:ComponentClass/SMLCL:Dynamics/SMLCL:StateVariable | /SMLCL:SpineML/SMLCL:ComponentClass/SMLCL:AnalogReducePort | /SMLCL:SpineML/SMLCL:ComponentClass/SMLCL:AnalogReceivePort"/>
							<xsl:with-param name="aliases" select="/SMLCL:SpineML/SMLCL:ComponentClass/SMLCL:Dynamics/SMLCL:Alias"/>
							<xsl:with-param name="string" select="SMLCL:MathInline"/>
							</xsl:call-template>;
</xsl:template>

</xsl:stylesheet>
