<?xml version="1.0" encoding="ISO-8859-1"?><xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:SMLNL="http://www.shef.ac.uk/SpineMLNetworkLayer" xmlns:SMLLOWNL="http://www.shef.ac.uk/SpineMLLowLevelNetworkLayer" xmlns:SMLCL="http://www.shef.ac.uk/SpineMLComponentLayer"xmlns:fn="http://www.w3.org/2005/xpath-functions">
<xsl:output method="text" version="1.0" encoding="UTF-8" indent="yes"/>

<xsl:template match="SMLCL:OnCondition" mode="doTrans">
<xsl:param name="suffix"/>
		  //OnCondition 
		  if (<xsl:call-template name="add_suffix">
									<xsl:with-param name="params" select="//SMLCL:StateVariable | //SMLCL:AnalogReducePort | //SMLCL:AnalogReceivePort"/>
									<xsl:with-param name="string" select="SMLCL:Trigger/SMLCL:MathInline"/>
									<xsl:with-param name="suffix" select="concat($suffix, '[i]')"/>
									</xsl:call-template>) {
			//transition = 1;<!---->
			<xsl:apply-templates select="SMLCL:StateAssignment" mode="doSA">
				<xsl:with-param name="suffix" select="$suffix"/>
			</xsl:apply-templates>
			<xsl:apply-templates select="SMLCL:EventOut">
				<xsl:with-param name="suffix" select="$suffix"/>
			</xsl:apply-templates>
			
			// Regime switch
			regimeNext=<xsl:value-of select="@target_regime"/><xsl:value-of select="translate(//SMLCL:ComponentClass/@name,' -','__')"/>;
		  }
</xsl:template>

<xsl:template match="SMLCL:OnCondition" mode="doTransSYN">
<xsl:param name="suffix"/>
		  //OnCondition 
		  if (<xsl:call-template name="add_suffix">
									<xsl:with-param name="params" select="//SMLCL:Parameter | //SMLCL:StateVariable | //SMLCL:AnalogReducePort | //SMLCL:AnalogReceivePort | //SMLCL:Alias"/>
									<xsl:with-param name="string" select="SMLCL:Trigger/SMLCL:MathInline"/>
									<xsl:with-param name="suffix" select="concat($suffix, '[i]')"/>
									</xsl:call-template>) {
			//transition = 1;<xsl:apply-templates select="SMLCL:StateAssignment">
				<xsl:with-param name="suffix" select="$suffix"/>
			</xsl:apply-templates>
			<xsl:apply-templates select="SMLCL:EventOut">
				<xsl:with-param name="suffix" select="$suffix"/>
			</xsl:apply-templates>
			
			// Regime switch
			regimeNext=<xsl:value-of select="@target_regime"/><xsl:value-of select="translate(//SMLCL:ComponentClass/@name,' -','__')"/>;
		  }
</xsl:template>

<xsl:include href="SpineML_StateAssignment.xsl"/>
<xsl:include href="SpineML_EventOut.xsl"/>
<!--xsl:include href="SpineML_Trigger.xsl"/-->

</xsl:stylesheet>
