<?xml version="1.0" encoding="ISO-8859-1"?><xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:SMLNL="http://www.shef.ac.uk/SpineMLNetworkLayer" xmlns:SMLLOWNL="http://www.shef.ac.uk/SpineMLLowLevelNetworkLayer" xmlns:SMLCL="http://www.shef.ac.uk/SpineMLComponentLayer"xmlns:fn="http://www.w3.org/2005/xpath-functions">
<xsl:output method="text" version="1.0" encoding="UTF-8" indent="yes"/>

<xsl:template match="SMLNL:Property" mode="fillConnectivityForWeightUpdateAlias">
<xsl:param name="suffix"/>
<xsl:param name="popSize"/>
<xsl:param name="srcPopSize"/><xsl:text>
</xsl:text>
<xsl:for-each select="SMLNL:FixedValue">
<xsl:variable name="line">{<xsl:call-template name="RepeatString">
      <xsl:with-param name="string" select="@value" />
	  <xsl:with-param name="divider" select="','" />
      <xsl:with-param name="times"  select="$popSize" />
    </xsl:call-template>}</xsl:variable>
<xsl:value-of select="../@name"/><xsl:value-of select="$suffix"/> = {<xsl:call-template name="RepeatString">
      <xsl:with-param name="string" select="$line" />
	  <xsl:with-param name="divider" select="',&#13;'" />
      <xsl:with-param name="times"  select="$srcPopSize" />
    </xsl:call-template>};
</xsl:for-each>
</xsl:template>

<xsl:template match="SMLNL:Property" mode="fillForWeightUpdateAlias">
<xsl:param name="suffix"/>
<xsl:param name="popSize"/>
<xsl:param name="component"/>
<xsl:param name="srcPopSize"/><xsl:text>
</xsl:text>
<xsl:variable name="propname" select="@name"/>

<xsl:if test="count($component//SMLCL:Parameter[@name=$propname])=1">
	<xsl:for-each select="SMLNL:FixedValue">
	<xsl:value-of select="../@name"/><xsl:value-of select="$suffix"/> = <xsl:value-of select="@value"/>;
	</xsl:for-each>
</xsl:if>

<xsl:if test="count($component//SMLCL:StateVariable[@name=$propname])=1">
	<xsl:for-each select="SMLNL:FixedValue">
	<xsl:variable name="line">{<xsl:call-template name="RepeatString">
		  <xsl:with-param name="string" select="@value" />
		  <xsl:with-param name="divider" select="','" />
		  <xsl:with-param name="times"  select="$popSize" />
		</xsl:call-template>}</xsl:variable>
	<xsl:value-of select="../@name"/>SD<xsl:value-of select="$suffix"/> = {<xsl:call-template name="RepeatString">
		  <xsl:with-param name="string" select="$line" />
		  <xsl:with-param name="divider" select="',&#13;'" />
		  <xsl:with-param name="times"  select="$srcPopSize" />
		</xsl:call-template>};
	</xsl:for-each>
</xsl:if>
</xsl:template>


<xsl:template match="SMLNL:Property" mode="fillForAlias">
<xsl:param name="suffix"/>
<xsl:param name="popSize"/><xsl:text>
</xsl:text>
<xsl:for-each select="SMLNL:FixedValue">
<!-- if there is no explicit list -->
<xsl:if test="count(../SMLNL:ValueList)=0">
<xsl:value-of select="../@name"/><xsl:value-of select="$suffix"/> = {<xsl:call-template name="RepeatString">
      <xsl:with-param name="string" select="@value" />
	  <xsl:with-param name="divider" select="','" />
      <xsl:with-param name="times"  select="$popSize" />
    </xsl:call-template>};
</xsl:if>
</xsl:for-each>
<xsl:for-each select="SMLNL:ValueList">
<xsl:variable name="default">
        <xsl:if test="count(../SMLNL:FixedValue)>0"><xsl:value-of select="../SMLNL:FixedValue/@value"/></xsl:if>
        <xsl:if test="count(../SMLNL:FixedValue)=0">0</xsl:if>
</xsl:variable>
<xsl:value-of select="../@name"/><xsl:value-of select="$suffix"/> = <xsl:call-template name="RepeatStringIndividualVals1D">
      <xsl:with-param name="default" select="$default" />
      <xsl:with-param name="times"  select="$popSize" />
      <xsl:with-param name="input"  select="." />
    </xsl:call-template>;
</xsl:for-each>
</xsl:template>


<xsl:template match="SMLNL:Property" mode="randomPropertiesSYN">
<xsl:param name="suffix"/>
<xsl:variable name="name" select="@name"/>
<xsl:for-each select="SMLNL:UniformDistribution">
	for (j=0; j &lt; NEURONS_PER_CORE; j += 1) {
                tempf[j] = uniformRNG((float) <xsl:value-of select="@maximum"/>, (float) <xsl:value-of select="@minimum"/>);
		printf("%f", tempf[j]);
	}
        writesdram(&amp;<xsl:value-of select="$name"/>SD<xsl:value-of select="$suffix"/>[i], &amp;tempf, NEURONS_PER_CORE);
</xsl:for-each>
</xsl:template>

<xsl:template match="SMLNL:Property" mode="randomProperties">
<xsl:param name="suffix"/>
<xsl:variable name="name" select="@name"/>
<xsl:for-each select="SMLNL:UniformDistribution">
	<xsl:text>	</xsl:text>
        <xsl:value-of select="$name"/><xsl:value-of select="$suffix"/>[i] = uniformRNG((float) <xsl:value-of select="@maximum"/>, (float) <xsl:value-of select="@minimum"/>);
</xsl:for-each>
</xsl:template>

<xsl:template match="SMLNL:Property" mode="randomConnSetPropertiesSYN">
<xsl:param name="suffix"/>
<xsl:for-each select="SMLNL:FixedValue">
<xsl:value-of select="../@name"/><xsl:value-of select="$suffix"/>[counter] = <xsl:value-of select="@value"/>;
</xsl:for-each>
<xsl:if test="count(SMLNL:FixedValue | SMLNL:UniformDistribution | SMLNL:NormalDistribution | SMLNL:ValueList)=0">
<xsl:value-of select="../@name"/><xsl:value-of select="$suffix"/>[counter] = 0;
</xsl:if>
</xsl:template>

<xsl:template match="SMLNL:Property" mode="randomConnCreateTempSYN">
<xsl:param name="suffix"/>
float <xsl:value-of select="@name"/><xsl:value-of select="$suffix"/>
</xsl:template>


<xsl:template match="SMLNL:Property" mode="randomConnSetEndSYN">
<xsl:param name="suffix"/>
<xsl:value-of select="@name"/><xsl:value-of select="$suffix"/>[counter] = -1;
</xsl:template>

<xsl:template match="SMLNL:Property" mode="randomConnWriteSYN">
<xsl:param name="suffix"/>
<xsl:param name="dest_size"/>
		writesdram(&amp;<xsl:value-of select="@name"/>SD<xsl:value-of select="$suffix"/>[i], &amp;<xsl:value-of select="@name"/><xsl:value-of select="$suffix"/>, <xsl:value-of select="ceiling(6.0*number($dest_size)*number(../../SMLNL:FixedProbabilityConnection/@probability))"/>);
</xsl:template>

</xsl:stylesheet>
